; 2000 bytes SYS FILE
;
; Compile:
;       tasm /zi /m3 rosegoat.asm
;       tlink /m /v rosegoat.obj
;       tdstrip -c rosegoat.exe
;       ren rosegoat.com rosegoat.sys
;       Install rosegoat.sys with a DEVICE command in your CONFIG.SYS
;
.model  tiny
.code
org     0

Silly_SYS:                              ; SYS Header
Next_Device dd  0ffffffffh              ; Just one device
Attribute dw    8000h                   ; Type: character device
Strategy dw     offset Strategy_Routine
Interrupt dw    offset Interrupt_Routine
NameDevice db   'SYS_GOAT'

db      100     dup (?)

Strategy_Routine:                       ; Save ES:BX, address of the request header
        mov     word ptr cs:[Request_Header],bx
        mov     word ptr cs:[Request_Header+2],es
        retf

db      100     dup (?)

Interrupt_Routine:                      ; The heart of the program
        push    ds
        push    cs
        pop     ds                      ; DS=CS

                                        ; Here, we points ES:BX to the request header
        les     bx,dword ptr ds:[Request_Header]
        mov     al,byte ptr es:[bx+2]   ; Take the command byte
        test    al,al                   ; Is 0? That means, initialization
        jnz     Go_Out                  ; Nope

                                        ; Here we set the segment and ending offset of the program
                                        ; and with a 100h we indicate to DOS that all was sucessfull
        mov     word ptr es:[bx+03h],0100h
        mov     word ptr es:[bx+0eh],offset Ending
        mov     word ptr es:[bx+010h],cs

                                        ; Display the rosegoat msg

        mov     cx, Ending - Message
        mov     si,offset Message
lp:
        push    cx
        lodsb
        mov     ah, 0eh
        mov     bx, 14
        mov     cx, 1
        int     10h
        pop     cx
        loop    lp

        pop     ds
Go_Out: sub     ax,ax
        retf                            ; Return

Request_Header dw 0,0           ; This will hold the address passed by DOS

Message db 13, 10
        db      '-------=[  ROSEGOAT 1.02  SYS GOAT DRIVER by ROSE SWE!  ]=-------',13,10

Ending:

org     1999
        db      0               ; make it 2000 bytes

End     Silly_SYS

